###############################################################################
# Notify.pl                                                                   #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
# =========================================================================== #
# Re-written for Notify Once 2 by BHRA Webmaster.                             #
###############################################################################

$notifyplver = "1 Gold - SP 1.3+";

sub Notify2 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest') { &fatal_error($txt{'138'}); }
	$thread = $INFO{'thread'};
	if ($thread eq "") {$filename = qq~$boardsdir/$currentboard.mail~;} else {$filename = qq~$datadir/$thread.mail~;}

	fopen(FILE, "$filename");
	@mails = <FILE>;
	fclose(FILE);
	fopen(FILE, ">$filename", 1) || &fatal_error("$txt{'23'} $filename");
	print FILE "$settings[2]|0\n";
	foreach $curmail (@mails) {
		$curmail =~ s/[\n\r]//g;
		($curmail, $mail_sent) = split(/\|/,$curmail);
		if($settings[2] ne $curmail) { print FILE "$curmail|$mail_sent\n"; }
	}
	fclose(FILE);
	if ($thread eq "") {$yySetLocation = qq~$cgi~;} else {$yySetLocation = qq~$cgi;action=display;num=$thread;start=$INFO{'start'}~;}
	&redirectexit;
}

###############################################################################

sub Notify3 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
	$thread = $INFO{'thread'};
	if ($thread eq "") {$filename = qq~$boardsdir/$currentboard.mail~;} else {$filename = qq~$datadir/$thread.mail~;}

	fopen(FILE, "$filename");
	@mails = <FILE>;
	fclose(FILE);
	fopen(FILE, ">$filename", 1) || &fatal_error("$txt{'23'} $filename");
	foreach $curmail (@mails) {
		$curmail =~ s/[\n\r]//g;
		($curmail, $mail_sent) = split(/\|/,$curmail);
		if($settings[2] ne "$curmail") { print FILE "$curmail|$mail_sent\n"; }
	}
	fclose(FILE);
	if (-z "$filename") { unlink("$filename"); }
	if ($thread eq "") {$yySetLocation = qq~$cgi~;} else {$yySetLocation = qq~$cgi;action=display;num=$thread;start=$INFO{'start'}~;}
	&redirectexit;
}

###############################################################################

sub Notify4 {
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
	my( $variable, $dummy, $dummy2, $threadno, @mails, $curmail );

	foreach $variable (keys %FORM) {
	 	$dummy = $FORM{$variable};
		($dummy2, $threadno) = split(/-/,$variable);
		if ($dummy2 eq "thread" || $dummy2 eq "board") {
			if ($dummy2 eq "thread") {$filename = "$datadir/$threadno.mail";} else {$filename = "$boardsdir/$threadno.mail";}

			fopen(FILE, "$filename");
			@mails = <FILE>;
			fclose(FILE);

			fopen(FILE, ">$filename") || &fatal_error("$txt{'23'} $threadno.mail");
			foreach $curmail (@mails) {
				$curmail =~ s/[\n\r]//g;
				($curmail, $mail_sent) = split(/\|/,$curmail);
				if($settings[2] ne $curmail) { print FILE "$curmail|$mail_sent\n"; }
			}
			fclose(FILE);
			if (-z "$filename") { unlink("$filename"); }
		} 
	}

	$yySetLocation = qq~$cgi~;
	&redirectexit;
}

###############################################################################

sub ShowNotifications {
	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }

	my(@dirdata,@datdata,$filename,$entry,@entries,$mnum,$dummy,$msub,$mname,$memail,$mdate,$musername,$micon,$mattach,$mip,$mmessage,$tmpa,$tmpb,@messages,@found_number,@found_subject,@found_date,@found_username);

	&LoadCensorList;	# Load Censor List

	# Read all .mail-Files and search for username

	opendir (DIRECTORY,"$datadir");
	@dirdata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	unless ($enable_notification) {undef @dirdata;}
	@datdata = grep(/mail/,@dirdata);

	foreach $filename (@datdata) {
		fopen(FILE, "$datadir/$filename");
		@entries = <FILE>;
		fclose(FILE);
	        foreach $entry (@entries) {
	        	$entry =~ s/[\n\r]//g;
			($entry, $mail_sent) = split(/\|/,$entry);
	        	if ($entry eq $settings[2]) {
				($mnum, $dummy) = split(/\./,$filename);
				fopen(FILE, "$datadir/$mnum.txt");
				@messages = <FILE>;
				fclose(FILE);
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage) = split(/\|/,$messages[0]);

				fopen(FILE, "$datadir/$mnum.data");
				$dummy = <FILE>;
				$mboard = <FILE>;
				fclose(FILE);
				chomp $mboard;

				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$msub =~ s~\Q$tmpa\E~$tmpb~gi;
				}
				if ($mboard ne "") {$msub = qq~<a href="$scripturl?board=$mboard;action=display;num=$mnum">$msub</a>~;}

				push(@found_number,$mnum);
				push(@found_subject,$msub);
				push(@found_date,$mdate);
				push(@found_username,$musername);
				push(@found_name,$mname);
			}
		}
	}

	opendir (DIRECTORY,"$boardsdir");
	@boarddata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	unless ($enable_board_notify) {undef @boarddata;}
	@datdata = grep(/mail/,@boarddata);

	foreach $filename (@datdata) {
		fopen(FILE, "$boardsdir/$filename");
		@entries = <FILE>;
		fclose(FILE);
	        foreach $entry (@entries) {
	        	$entry =~ s/[\n\r]//g;
			($entry, $mail_sent) = split(/\|/,$entry);
	        	if ($entry eq $settings[2]) {
				($boardid, $dummy) = split(/\./,$filename);
				fopen(FILE, "$boardsdir/$boardid.dat");
				$bname = <FILE>;
				fclose(FILE);
				chomp $bname;

				push(@found_boardid,$boardid);
				push(@found_bname,$bname);
			}
		}
	}

	# Display all Entries
	$yymain .= qq~
<br>
<form action="$cgi;action=notify4" method="post" style="display:inline">
<table border="0" align="center" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" width="100%">
  <tr>
    <td>
      <table width="100%" border="0" cellspacing="1" cellpadding="3">
        <tr>
          <td bgcolor="$color{'titlebg'}" class="titlebg"><img src="$imagesdir/notify.gif" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}" class="text1"><b>$txt{'418'}</b></font></td>
        </tr>~;

	if (@found_number == 0 && @found_boardid == 0 ) { $yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg'}" class="windowbg" align="center"><font size="2"><br>$txt{'414'}<br><br></font></td>
        </tr>~;
	}

	if (@found_boardid != 0 || @found_number != 0) {
 		$yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg'}" class="windowbg">~;


		if (@found_boardid != 0) {
 			$yymain .= qq~
            <br><font size="2">$bln_txt{'05'}:</font><br><br>
            <table border="0" cellspacing="0" cellpadding="0" width="90%" align="center">~;
		$counter = 0;
		foreach $entry (@found_boardid) { $yymain .= qq~
              <tr><td><input type="checkbox" name="board-$found_boardid[$counter]" value="1"> &nbsp; <b><i><a href="$scripturl?board=$found_boardid[$counter]">$found_bname[$counter]</a></i></b></td></tr>~;
			$counter++;
		}
		$yymain .= qq~
            </table><br>~;
		}

		if (@found_number != 0) {
			$yymain .= qq~
            <br><font size="2">$txt{'415'}:</font><br><br>
            <table border="0" cellspacing="0" cellpadding="0" width="90%" align="center">~;
			$counter = 0;
			foreach $entry (@found_number) {
				&FormatUserName($found_username[$counter]);
				if ($found_username[$counter] ne "Guest") { $found_name[$counter] = qq~<a href="$cgi;action=viewprofile;username=$useraccount{$found_username[$counter]}">$found_name[$counter]</a>~;}
				$found_date[$counter] = &timeformat($found_date[$counter], 1);
				if (-e "$datadir/$found_number[$counter].poll") {$ispoll = "$polltxt{'15'}: ";} else {$ispoll = ""}
				$yymain .= qq~
              <tr><td><input type="checkbox" name="thread-$found_number[$counter]" value="1"> &nbsp; <b>$ispoll<i>$found_subject[$counter]</i></b> - $txt{'109'} $found_name[$counter] $txt{'30'} $found_date[$counter]</td></tr>~;
				$counter++;
			}
			$yymain .= qq~
            </table><br>~;
		}
		$yymain .= qq~
            <br><center><font size="2">$txt{'416'}</font></center><br>
          </td>
        </tr>
        <tr>
          <td bgcolor="$color{'catbg'}" class="catbg" align="center"><input type="submit" value="$txt{'417'}"></td>
        </tr>~;
	}

	$yymain .= qq~
      </table>
    </td>
  </tr>
</table>
</form>~;

	$yytitle = "$txt{'417'}";
	&template;
	exit;
}

###############################################################################

sub remove_notifications {
	my (@deademails) = (@_);
	my (@datdata, @boarddata, $tmp, $filename, $content, $content_old);

	opendir (DIRECTORY,"$datadir");
	@datdata = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);
	foreach (@datdata) { $_ = "$datadir/".$_;}

	opendir (DIRECTORY,"$boardsdir");
	@boarddata = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);
	foreach (@boarddata) { $_ = "$boardsdir/".$_;}
	push (@datdata, @boarddata);

	foreach $filename (@datdata) {
		$content = '';
		$content_old = '';
		fopen(FILE, "+<$filename") || &fatal_error("$txt{'23'} $filename");
			while (<FILE>) {
				$tmp = $_;
				$content_old .= $tmp;
				foreach $tmp_email (@deademails) {$tmp =~ s/^$tmp_email(\|\d)?[\r\n]$//ig;}
				$content .= $tmp;
			}
			if ($content ne $content_old) {
				truncate(FILE,0);
				seek(FILE,0,0);
				print FILE $content;
			}
		fclose(FILE);
		if (-z "$filename") { unlink("$filename"); }
	}
}

###############################################################################

sub replace_notifications {
	my $old_email = $_[0];
	my $new_email = $_[1];
	my (@datdata, @boarddata, $tmp, $filename, $content, $content_old);

	opendir (DIRECTORY,"$datadir");
	@datdata = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);
	foreach (@datdata) { $_ = "$datadir/".$_;}

	opendir (DIRECTORY,"$boardsdir");
	@boarddata = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);
	foreach (@boarddata) { $_ = "$boardsdir/".$_;}
	push (@datdata, @boarddata);

	foreach $filename (@datdata) {
		$content = '';
		$content_old = '';
		fopen(FILE, "+<$filename") || &fatal_error("$txt{'23'} $filename");
			while (<FILE>) {
				$tmp = $_;
				$content_old .= $tmp;
				$tmp =~ s/^$old_email(?=\||[\n\r]|$)/$new_email/ig;
				$content .= $tmp;
			}
			if ($content ne $content_old) {
				truncate(FILE,0);
				seek(FILE,0,0);
				print FILE $content;
			}
		fclose(FILE);
		if (-z "$filename") { unlink("$filename"); }
	}
}

1;